/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pl.edu.icm.yadda.analysis.packscanner;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.NoSuchElementException;

import org.slf4j.LoggerFactory;

import pl.edu.icm.yadda.bwmeta.model.YElement;
import pl.edu.icm.yadda.bwmeta.model.YInstitution;
import pl.edu.icm.yadda.bwmeta.model.YPerson;
import pl.edu.icm.yadda.bwmeta.serialization.BwmetaReader;
import pl.edu.icm.yadda.bwmeta.serialization.BwmetaReader1;
import pl.edu.icm.yadda.common.YaddaException;
import pl.edu.icm.yadda.tools.BasicPackImporter;
import pl.edu.icm.yadda.tools.BasicPackImporterFactory;
import pl.edu.icm.yadda.tools.IImporter;
import pl.edu.icm.yadda.tools.OSSArchive;
import pl.edu.icm.yadda.tools.relations.FakeFacadesBeingIterator;

/**
 *
 * @author kura
 */
public class PackDirToYElementIterator implements  Iterator<YElement>{
   
  


  

       ArrayList<File> list;
       int pos;
       private void addThisAndAllSubFilesToArrayList(File file, ArrayList<File> li) {
           if (file.isFile()) {
               li.add(file);
           }
           if (file.isDirectory()) {
             for (File d:file.listFiles()) {
                  addThisAndAllSubFilesToArrayList(d, li);
             }
           }
       }
       
       public PackDirToYElementIterator(File file){
           list=new ArrayList<File>();
           addThisAndAllSubFilesToArrayList(file, list);
           pos=0;
       }

       Iterator<YElement> aktFileIterator=null;

        @Override
        public boolean hasNext() {
            if (aktFileIterator!=null && aktFileIterator.hasNext()) return true;
            while ((aktFileIterator==null || !aktFileIterator.hasNext() )&& pos<list.size()) {
               File f=list.get(pos);
               pos++;
               aktFileIterator=getYElementIterator(f.getAbsolutePath());
            
            }
            if (aktFileIterator!=null && aktFileIterator.hasNext()) return true;

            return false;
        }

        @Override
        public YElement next() {
           if (!hasNext()) throw new NoSuchElementException();
           return aktFileIterator.next();
        }

        @Override
        public void remove() {
            throw new UnsupportedOperationException("Not supported");
        }

   



  private   Iterator<YElement> getYElementIterator(String filename)
   {
         BasicPackImporterFactory fact=new BasicPackImporterFactory();
            final FakeFacadesBeingIterator facad=new FakeFacadesBeingIterator("BWMETA1");
                        OSSArchive arch=new OSSArchive();
                        arch.setArchiveFacade2(facad);
                        arch.setStorageFacade2(facad);
                        fact.setArchive(arch);
                        fact.setArchiveFacade2(facad);
                        fact.setCatalogFacade(facad);
                        fact.setEditorFacade(facad);
                        
                       final IImporter importer = fact.build(filename, true, IImporter.OverwriteMode.ALWAYS, true, new String[0], filename.substring(filename.lastIndexOf('.')+1).toUpperCase());
                     //  Logger.getLogger(PackDirToYElementIterator.class.getName()).log(Level.INFO, "got file format: "+((BasicPackImporter)importer).getFormat());


                       Thread t = new Thread() {

                        @Override
                        public void run() {
                            try {
                                importer.process();
                            } catch (Exception ex) {
                                LoggerFactory.getLogger(PackDirToYElementIterator.class).error("Exception caught", ex);
                            }
                            try {
                                facad.finish();

                            } catch (InterruptedException ex) {
                                LoggerFactory.getLogger(PackDirToYElementIterator.class).error("Exception caught", ex);
                            }
                            System.out.println("Pack processing finished");
                        }
                    };
                     t.start();
                   PrivateYElementIteratorFromStringIterator iter=new PrivateYElementIteratorFromStringIterator(facad, new BwmetaReader1());

                   return iter;

   }

  public static class PrivateYElementIteratorFromStringIterator implements Iterator<YElement> {

      Iterator<String> iter;
      protected BwmetaReader bwmetaReader;

        public PrivateYElementIteratorFromStringIterator(Iterator<String> iter, BwmetaReader bwmetaReader) {
            this.iter = iter;
            this.bwmetaReader = bwmetaReader;
        }

        @Override
        public boolean hasNext() {
            return !list.isEmpty() || iter.hasNext();
        }


        LinkedList<YElement> list=new LinkedList<YElement>();

        @Override
      public YElement next() {
          if (!list.isEmpty()) {
              return list.poll();
          }
          while (list.isEmpty()) {
              if (!hasNext()) {
                  throw new NoSuchElementException();
              }
                if (iter.hasNext()) {
                    try {
                        String data = iter.next();
                        Object t = bwmetaReader.read(data, null);
                        List a;
                        if (t instanceof List) {
                            a = (List) t;
                        } else {
                            a = new ArrayList();
                            a.add(t);
                        }
                        for (Object tmp : a) {
                           if (tmp instanceof YElement) {
                               list.add((YElement) tmp);
                            } else if (tmp instanceof YPerson) {
                            } else if (tmp instanceof YInstitution) {
                            }
                        }
                    } catch (YaddaException ex) {
                        LoggerFactory.getLogger(PackDirToYElementIterator.class).error("Exception caught", ex);
                    }
                   }

              
          }
          if (!list.isEmpty())
               return list.poll();
          throw new NoSuchElementException();

      }

        @Override
        public void remove() {
            throw new UnsupportedOperationException("Not supported");
        }



  }




}
