/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pl.edu.icm.yadda.remoting.cli.export;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.CommandLineParser;
import org.apache.commons.cli.GnuParser;
import org.apache.commons.cli.HelpFormatter;
import org.apache.commons.cli.Option;
import org.apache.commons.cli.Options;
import org.apache.commons.cli.ParseException;
import pl.edu.icm.yadda.export.PackCreatorBasedExporter;
import pl.edu.icm.yadda.remoting.discover.ServiceDiscoverer;
import pl.edu.icm.yadda.service2.browse.facade.BrowserFacade;
import pl.edu.icm.yadda.service2.catalog.impl.CatalogFacade;
import pl.edu.icm.yadda.service2.user.UserCatalogConstants;
import pl.edu.icm.yadda.service2.user.domain.DescriptorBasedDomainBuilder;
import pl.edu.icm.yadda.service2.user.token.AnonymousToken;
import pl.edu.icm.yadda.service2.user.token.IpAwareLoginPasswordToken;

/**
 *
 * @author kura
 */
public class DescriptorBasedRepoExporter {
   PackCreatorBasedExporter exporter=new PackCreatorBasedExporter();
   ServiceDiscoverer disc=new ServiceDiscoverer();
   boolean doChunk=true;



   public void doExport( String outDir, ArrayList<String> ids) throws Exception {
       BrowserFacade broser=(BrowserFacade) disc.getService("browse");
       CatalogFacade catalog=(CatalogFacade) disc.getService("catalog");

        exporter.setBrowserFacade(broser);
        exporter.setCatalogFacade(catalog);
        exporter.setOutDirectory(outDir);
        exporter.setList(ids);
        exporter.setDoChunk(doChunk);
        


            exporter.setBwMetaReader(new pl.edu.icm.yadda.bwmeta.serialization.BwmetaReader1());
            exporter.setExportOthers(true);
            exporter.setPartType("BWMETA1");
            exporter.setPackSize(200000);


            exporter.process();
   }

      
	protected static final String O_DESCR = "descr";
	protected static final String O_STOREDIR = "store-dir";
	protected static final String O_HELP = "help";
	protected static final String O_IPADDR = "ip-addr";
	protected static final String O_USER = "user";
	protected static final String O_PASS = "pass";
	protected static final String O_DOMAIN = "domain";
        protected static final String O_FILE = "file";
        protected static final String O_NO_CHUNK = "no-chunk";

        protected static Options defineOptions() {
		Options options = new Options();

		Option oDescr = new Option("d", O_DESCR, true, "repository descriptor");
		oDescr.setRequired(true);
		options.addOption(oDescr);
		Option oHelp = new Option("h", O_HELP, false, "this help message");
		options.addOption(oHelp);
		Option oIpAddr = new Option("i", O_IPADDR, true, "IP address to show to AAS (only for secured repos)");
		options.addOption(oIpAddr);
		Option oStoreDir = new Option("s", O_STOREDIR, true, "directory for storing packs");
		oStoreDir.setRequired(true);
		options.addOption(oStoreDir);
		Option oPass = new Option("p", O_PASS, true, "password to show to AAS (only for secured repos)");
		options.addOption(oPass);
		Option oUser = new Option("u", O_USER, true, "user name to show to AAS (only for secured repos)");
		options.addOption(oUser);
		Option oDomain = new Option("domain", O_DOMAIN, true, "user domain (only for secured repos)");
		options.addOption(oDomain);
        Option oList = new Option("f", O_FILE, true, "file with id list");
		options.addOption(oList);
        Option oNoChunk = new Option("n", O_NO_CHUNK, false, "set this option if you dont want to get pack with mega chunks");
		options.addOption(oNoChunk);
		return options;
	}

	protected static void usage(Options options) {
		HelpFormatter helpFormatter = new HelpFormatter();
		PrintWriter writer = new PrintWriter(System.out);
		helpFormatter.printUsage(writer, 80, DescriptorBasedRepoExporter.class.getSimpleName(), options);
		helpFormatter.printOptions(writer, 80, options, 1, 2);
		writer.flush();
	}


	protected static String getDomain(CommandLine commandLine, ServiceDiscoverer disc) {
		if (commandLine.hasOption(O_DOMAIN)) {
//			returning from commandline
			return commandLine.getOptionValue(O_DOMAIN);
		} else {
//			returning from descriptor
			if (disc.getProperties().containsKey(UserCatalogConstants.DOMAIN_ROOT_PROPERTY)) {
				return disc.getProperties().get(UserCatalogConstants.DOMAIN_ROOT_PROPERTY) + 
					UserCatalogConstants.DL_DOMAIN_SUFFIX;
			} else {
				return null;
			}
		}
	}


   public static void main(String[] args) throws Exception {
          ArrayList<String> list=new ArrayList<String>();
          Options options = defineOptions();
		CommandLineParser parser = new GnuParser();
		try {
			CommandLine commandLine = parser.parse(options, args);
			if (commandLine.hasOption(O_HELP))
				throw new ParseException("");

			String ipAddr = commandLine.getOptionValue(O_IPADDR);
			String user = commandLine.getOptionValue(O_USER);
			String pass = commandLine.getOptionValue(O_PASS);
			DescriptorBasedRepoExporter exporter=new DescriptorBasedRepoExporter();
                        if (commandLine.hasOption(O_NO_CHUNK)) {
                            exporter.doChunk=false;
                        }
                        exporter.disc.setDescriptorUrl(commandLine.getOptionValue(O_DESCR));
                        exporter.disc.afterPropertiesSet();
                        if (exporter.disc.isSecured()) {
                           if (user!=null) {
                               exporter.disc.getAuthenticationManager().login(
                            		   new IpAwareLoginPasswordToken(user, pass, ipAddr, 
                            				   getDomain(commandLine, exporter.disc)));
                           } else  {
                              if (ipAddr!=null ) {
                               exporter.disc.getAuthenticationManager().login(
                            		   new AnonymousToken(ipAddr));
                             } else  {
                                exporter.disc.getAuthenticationManager().login(
                             		   new AnonymousToken("212.87.14.73"));  
                             }
                            }
                        }

                        String outDir= commandLine.getOptionValue(O_STOREDIR);
                        String idList= commandLine.getOptionValue(O_FILE);
                        ArrayList<String> ids=new ArrayList<String>();
                        BufferedReader reader=new BufferedReader(new FileReader(idList));

                        String id;
                        while ((id=reader.readLine())!=null) {
                            ids.add(id);
                        }
                        reader.close();

                        exporter.doExport(outDir, ids);

		} catch (ParseException e) {
			usage(options);
		}

   }


}
